/*
   See pages 176-179, Figure 6.16, from "Principles of Parallel Programming".
*/

void InitializeData(float*** new_p, float*** val_p, int n)
{
   int i, j;
   float** val;
   float** new;

   /* allocate storage */
   val = (float**)malloc( n*sizeof(float*) );
   for(i = 0; i < n; i++)
   {
      val[i] = (float*)malloc( n*sizeof(float) );
   }
   /* initialize to 0.0 */
   for(i = 0; i < n; i++)
   {
      for(j = 0; j < n; j++)
      {
         val[i][j] = 0.0;
      }
   }
   /* now put in boundary conditions */
   for(i = n/4; i < n-(n/4); i++)
   {
      val[i][0] = 1.0; /* part of left edge */
   }
   for(i = 0; i < (n/4); i++)
   {
      val[i][n-1] = 1.0;      /* part of right edge */
      val[n-1-i][n-1] = 1.0;  /* part of right edge */
   }

   /* make array new a copy of array val */
   new = (float**)malloc( n*sizeof(float*) );
   for(i = 0; i < n; i++)
      new[i] = (float*)malloc( n*sizeof(float) );
   for(i = 0; i < n; i++)
      for(j = 0; j < n; j++)
         new[i][j] = val[i][j];

   *new_p = new;
   *val_p = val;
}/* InitializeData() */